/*
* Copyright (C) 2009 HBM Netherlands B.V.
* Schutweg 15a
* 5145 NP Waalwijk
* The Netherlands
* http://www.hbm.com
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
*/

#ifndef CONNECTION_H
#define CONNECTION_H

#include "GEN_DAQ_API.h"
#include "jsonrpc.h"

GHSReturnValue ConnectionEstablish(GHSConnectionHandle *handle, const char *ipAddress, unsigned short portno);
GHSReturnValue ConnectionReadRaw(GHSConnectionHandle *handle, char *raw, int size);
GHSReturnValue ConnectionWriteRaw(GHSConnectionHandle *handle, const char *raw, int size);
GHSReturnValue ConnectionSendRequestWaitResponse(GHSConnectionHandle *handle, const char *request, int requestID, JsonRpcNamedParameter **params, size_t *numParams);
GHSReturnValue ConnectionClose(GHSConnectionHandle *handle);
uint16_t ConnectionNextRequestID(GHSConnectionHandle *handle);

#endif /* CONNECTION_H */
